﻿unit wnd_util;
{$Warnings off}
{$hints off}
{------------------------------------------------------------------}
{ Crossplatform opengl application unit                            }
{------------------------------------------------------------------}
{ By SVSD_VAL                                                      }
{------------------------------------------------------------------}
{ version: 0.1;                                                    }
{ site   : http://www.rtbt.ru                                      }
{ mail   : valdim_05@mail.ru                                       }
{ icq    : 223-725-915                                             }
{ jabber : svsd_val@jabber.ru                                      }
{------------------------------------------------------------------}
{ (04.12.2009)                                                     }
{------------------------------------------------------------------}

interface

uses
  OpenGL15,
{$IFDEF Win32}
  Windows,messages
{$else}
  Unix, GLX, X, XLib, XUtil, keysym
{$endif};

Const
  WndName     :Pchar = 'by SVSD_VAL, for http://LinGameTech.com [fpc OpenGL_App.dpr -Sd -XsX]';
  PrjName     :Pchar = 'OpenGL - OpenGL';
  vk_MouseLeft  = 0;
  vk_MouseRight = 1;
  vk_MouseMiddle= 2;
  vk_BACKSPACE  = 8;
  vk_TAB        = 9;
  vk_ENTER      = 13;
  vk_SHIFT      = 16;
  vk_SHIFT_L    = 160;
  vk_SHIFT_R    = 161;
  vk_CTRL       = 17;
  vk_CTRL_L     = 162;
  vk_CTRL_R     = 163;
  vk_ALT        = 18;
  vk_ALT_L      = 164;
  vk_ALT_R      = 165;
  vk_PAUSE      = 19;
  vk_ESCAPE     = 27;
  vk_SPACE      = 32;

  vk_PAGEUP     = 33;
  vk_PAGEDOWN   = 34;
  vk_END        = 35;
  vk_HOME       = 36;
  vk_SNAPSHOT   = 44;
  vk_INSERT     = 45;
  vk_DELETE     = 46;

  vk_LEFT       = 37;
  vk_UP         = 38;
  vk_RIGHT      = 39;
  vk_DOWN       = 40;

  vk_0          = 48;
  vk_1          = 49;
  vk_2          = 50;
  vk_3          = 51;
  vk_4          = 52;
  vk_5          = 53;
  vk_6          = 54;
  vk_7          = 55;
  vk_8          = 56;
  vk_9          = 57;

  vk_NUMPAD0    = 96;
  vk_NUMPAD1    = 97;
  vk_NUMPAD2    = 98;
  vk_NUMPAD3    = 99;
  vk_NUMPAD4    = 100;
  vk_NUMPAD5    = 101;
  vk_NUMPAD6    = 102;
  vk_NUMPAD7    = 103;
  vk_NUMPAD8    = 104;
  vk_NUMPAD9    = 105;

  vk_MULTIPLY   = 106;
  vk_ADD        = 107;
  vk_SEPARATOR  = 108;
  vk_SUBTRACT   = 109;
  vk_DECIMAL    = 110;
  vk_DIVIDE     = 111;

  vk_A          = 65;
  vk_B          = 66;
  vk_C          = 67;
  vk_D          = 68;
  vk_E          = 69;
  vk_F          = 70;
  vk_G          = 71;
  vk_H          = 72;
  vk_I          = 73;
  vk_J          = 74;
  vk_K          = 75;
  vk_L          = 76;
  vk_M          = 77;
  vk_N          = 78;
  vk_O          = 79;
  vk_P          = 80;
  vk_Q          = 81;
  vk_R          = 82;
  vk_S          = 83;
  vk_T          = 84;
  vk_U          = 85;
  vk_V          = 86;
  vk_W          = 87;
  vk_X          = 88;
  vk_Y          = 89;
  vk_Z          = 90;

  vk_F1         = 112;
  vk_F2         = 113;
  vk_F3         = 114;
  vk_F4         = 115;
  vk_F5         = 116;
  vk_F6         = 117;
  vk_F7         = 118;
  vk_F8         = 119;
  vk_F9         = 120;
  vk_F10        = 121;
  vk_F11        = 122;
  vk_F12        = 123;

Type
  PVec2I      =^TVec2I;
  TVec2I      = Record
   X ,Y : Integer;
  end;

var
  Width       : Integer = 640;             // Щирена окна
  Height      : Integer = 480;             // Высота окна
  BPP         : Integer = 16;              // Глубина цвета
  FULLSCREEN  : Boolean = FALSE;           // В полноэранном режиме
  Done        : boolean;                   // Закончена ли работа программы ?
  keys        : Array[0..255] of Boolean;  // Здесь у нас хранятся все нажатые кнопки
  Frames,                                  // Статистика сколько кадров уже отрисовано
  FPSTime,fps,                             // Таймер на 1 сек и колво кадров в сек
  FrameTime,                               // Скорост 1 кадра (для независимости от FPS)
  LastTime    : Integer;                   // Последнее время кадра
  Appdir      : String;

  h_Wnd       : Cardinal;                     // Хендел окна (номер его у винды)
  pInit,
  pProcess,
  pDestroy    : Procedure;


Procedure CreateMainLoop;
// Функция проверки существования файла
function FileExists     (const FileName: string): boolean;
// Функция возвращает путь к файлу
function ExtractFilePath(const s: string): string;
// Функция возвращяет имя файла
function ExtractFileName(const s: string): string;
// Функция сменты файлового расширения
function ChangeFileExt  (const FileName, Extension: string): string;
// Простая функция для сложения двух строк , просто в конце добовляю \ или / :D
function AddDir         (const S, Dir : string): string;
// Установка позиции курсора
Procedure SetMPos       (const P: PVec2I);
// Получение позиции курсора
Procedure GetMPos       (const P: PVec2I);

implementation

function FileExists(const FileName: string): boolean;
var
 F: File;
begin
FileMode := 64;
AssignFile(F, FileName);
{$I-}
Reset(F);
{$I+}
Result := IOResult = 0;
if Result then
 CloseFile(F);
end;


function ExtractFilePath(const s: string): string;
var
 i : integer;
begin
    for i :=length(s)-1 downto 1 do
    {$ifdef Win32}
    if s[i]='\' then
    {$else}
    if s[i]='/' then
    {$endif}
    begin
    result := copy(s,1,i);
    exit;
    end;
end;

function ExtractFileName(const s: string): string;
var
i :integer;
begin
Result:=S;
    for i :=length(s)-1 downto 1 do
    {$IFDEF Win32}
    if s[i]='\' then
    {$else}
    if s[i]='/' then
    {$endif}
    begin
    result := copy(s,i+1,length(s)-1);
    exit;
    end;
end;


function AddDir(const S, Dir : string): string;
begin
Result := S+Dir;
{$ifdef Win32}
Result := Result +'\';
{$else}
Result := Result +'/';
{$endif}
end;


function ChangeFileExt(const FileName, Extension: string): string;
var
  I : Integer;
  S : String;
begin
  I := POS('.',FileName);
  s := Copy(FileName,1,i-1);
  Result := S+Extension;
end;

{$IFDEF Win32}
var
  h_DC,                                       // Канвас программы
  h_RC        : Cardinal;                     // Хендел Огла

  WndClass    : TWndClass;                 // Класс окна ( стиль , бордюр и тд)
{$else}
var
  V_Info      : PXVisualInfo;
  h_DC        : PDisplay;
  h_RC        : GLXContext;
  Attr        : TXSetWindowAttributes;
  WM_DelWnd   : TAtom;
  CursorPos   : Array [0..1] of integer;


function ConvertKey( KeyCode : WORD ) : Byte;
begin
  case KeyCode of
    XK_BackSpace      : result := vk_BACKSPACE;
    XK_Tab            : result := vk_TAB;
    XK_Return         : result := vk_ENTER;
    XK_Shift_L        : result := vk_SHIFT_L;
    XK_Shift_R        : result := vk_SHIFT_R;
    XK_Control_L      : result := vk_CTRL_L;
    XK_Control_R      : result := vk_CTRL_R;
    XK_Alt_L          : result := vk_ALT_L;
    XK_Alt_R          : result := vk_ALT_R;
    XK_Pause          : result := vk_PAUSE;
    XK_Escape         : result := vk_ESCAPE;
    XK_Space          : result := vk_SPACE;

    XK_Page_Up        : result := vk_PAGEUP;
    XK_Page_Down      : result := vk_PAGEDOWN;
    XK_End            : result := vk_END;
    XK_Home           : result := vk_HOME;
    XK_Sys_Req        : result := vk_SNAPSHOT;
    XK_Insert         : result := vk_INSERT;
    XK_Delete         : result := vk_DELETE;

    XK_Left           : result := vk_LEFT;
    XK_Up             : result := vk_UP;
    XK_Right          : result := vk_RIGHT;
    XK_Down           : result := vk_DOWN;

    XK_KP_Multiply    : result := vk_MULTIPLY;
    XK_KP_Add         : result := vk_ADD;
    XK_KP_Separator   : result := vk_SEPARATOR;
    XK_KP_Subtract    : result := vk_SUBTRACT;
    XK_KP_Decimal     : result := vk_DECIMAL;
    XK_KP_Divide      : result := vk_DIVIDE;
    XK_0   .. XK_9    : result := KeyCode - ( XK_0 - vk_0 );
    XK_KP_0.. XK_KP_9 : result := KeyCode - ( XK_KP_0 - vk_NUMPAD0 );
    XK_A   .. XK_Z    : result := KeyCode - ( XK_A - vk_A );
    XK_F1  .. XK_F12  : result := KeyCode - ( XK_F1 - vk_F1 );
  end;
end;

{$endif}


Procedure GetMPos(const P: PVec2I);
 {$IfDef Win32}
var
 M : TPoint;
 R : TRect;
 {$endIf}
begin
 {$IfDef Win32}
  GetCursorPos(M);
  GetWindowRect(h_wnd,r);
     p.x := m.x - r.left;
     p.y := m.y - r.top;

  if p.x < 0        then p.x := 0;
  if p.x > R.Right  then p.x := r.Right;
  if p.y < 0        then p.y := 0;
  if p.y > R.Bottom then p.y := r.Bottom;

 {$else}
  P.x := CursorPos[0];
  P.y := CursorPos[1];
 {$endIf}
end;

Procedure SetMPos(const P: PVec2I);
 {$IfDef Win32}
var
 R : TRect;
 {$endIf}
begin
 {$IfDef Win32}
  GetWindowRect(h_wnd,r);
  if p.x-r.left > R.Right  then p.x := r.Right;
  if p.y-r.top  > R.Bottom then p.y := r.Bottom;
  SetCursorPos(r.left + P.X, r.top + P.Y);
 {$else}
  XWarpPointer (h_dc, 0,h_wnd, 0,0, 0,0, p^.x, p^.y );
 {$endIf}

end;


{$IFDEF Win32}
{ ------------------------------------------------------------------------ }
{ --Считываем комманды отосланые этому окну------------------------------- }
{ ------------------------------------------------------------------------ }
function WndProc(Wnd:HWND;Msg,wParam,lParam:Integer):Integer;stdcall;
begin
  Result:=0;
	case msg of
    WM_CLOSE       : PostQuitMessage(0);                       // Выключение окна
    WM_LBUTTONDOWN, WM_LBUTTONUP   :
                     keys[vk_MouseLeft  ] := MSG = WM_LBUTTONDOWN;

    WM_RBUTTONDOWN, WM_RBUTTONUP   :
                     keys[vk_MouseRight ] := MSG = WM_RBUTTONDOWN;

    WM_MBUTTONDOWN, WM_MBUTTONUP   :
                     keys[vk_MouseMiddle] := MSG = WM_MBUTTONDOWN;

    WM_KEYDOWN: keys[wParam]:=TRUE;                       // Нажатие клавиши
    WM_KEYUP  : keys[wParam]:=FALSE;                      // Отпускание клавиши
    else Result:=DefWindowProc(Wnd,Msg,wParam,LParam);    // если другие остовляем их
  end;
end;

Procedure CreateWND;
var
  d           : DEVMODE;
  pfd         : TPixelFormatDescriptor; // Установка формата окна и разрешаем ему юзать OpenGL
  I           : Integer;
begin
  Done:=FALSE;                // Программа неокончила свою работу
  ZeroMemory(@d, SizeOf(d));  // Очистка режима окна
  with d do
  begin
    dmSize      := SizeOf(d); // Установка его размера
    dmPelsWidth := Width;     // Ширена окна
    dmPelsHeight:= Height;    // Высота окна
    dmBitsPerPel:= Bpp;       // Глубина цвета
    dmFields:=DM_PELSWIDTH or DM_PELSHEIGHT or DM_BITSPERPEL;
  end;

  if FULLSCREEN = true then   // Если полный экран разрешён то переводим его :)
  ChangeDisplaySettings(d,CDS_FULLSCREEN);

  with WndClass do            // Настройка окна
  begin
    Style:=CS_HREDRAW or CS_VREDRAW;                  // его стиль
    hIcon:=LoadIcon(GetModuleHandle(nil),'MAINICON'); // его иконка
    lpfnWndProc  := @WndProc;                         // куда винда кидает сообщение
    hInstance    := hInstance;                        // к хендлу системы
    lpszClassName:= PrjName;                          // его имя
    hCursor:=LoadCursor(0,IDC_ARROW);                 // тип курсора на нём
  end;

  RegisterClass(WndClass);                            // Регистрируем класс
  H_Wnd:=CreateWindow(PrjName,WndName,
  		 WS_POPUP,0,0,Width,height,0,0,hInstance,nil);  // Создаём окно и крепим его к хендлу
  ShowWindow(H_Wnd,SW_SHOW);                          // Показываем окно

  SetCursorPos(Width DIV 2,Height DIV 2);             // Установка крусора мыши
  ShowCursor(FALSE);                                  // Отключаем его отрисовку на окне
  SetForeGroundWindow(H_wnd);                         // Фокусируем винду на окно (делаем его основным)
  SetFocus(H_wnd);                                    // Фокусируем винду на окно (делаем его основным)


  FillChar ( pfd , sizeof (pfd) ,0); // Очищаем его
  H_DC           := GetDC(h_Wnd);    // Получаем доступ к хенделу окна
  pfd.nSize      := SizeOf(pfd);     // Устанавливаем его размер
  pfd.nVersion   := 1;               // Версию
  pfd.dwFlags    := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER; // Возможности
  pfd.iPixelType := PFD_TYPE_RGBA;   // Тип пикселей
  pfd.cColorBits := BPP;             // кол-во бит на цвета
  pfd.cDepthBits := 24;              // кол-во бит на глубину
  i:=ChoosePixelFormat(H_DC,@pfd);   // Выбераем нужный формат
  SetPixelFormat(H_DC,i,@pfd);       // Устанавливаем формат
  H_RC:=wglCreateContext(H_DC);      // Создаём OGL'овский контент
  wglMakeCurrent(H_DC,H_RC);         // Делаем его основным

end;

Function GetMessages:boolean;
var
 msg  : TMsg;                      // Сообщения к окну
begin
 Result:=false;
    if (PeekMessage(msg, 0, 0, 0, PM_REMOVE)) then    // Чтение сообщений прийденых к окну
     begin
       if Msg.message=WM_QUIT then Done:=TRUE;        // Если сообщение на закрытие
       TranslateMessage(Msg);                         // Перенос сообщения от винды к игре
       DispatchMessage(Msg);                          // Отправление сообщение видне что всё Ок и текущих изменениях
     end else Result := true;
end;
{$else}

procedure CreateWND;
const
 ogl_Attr : Array [0..12] of Cardinal = (             // Параметры создаваемого OpenGL контекста
  GLX_RGBA,
  glx_red_size  , 1,
  GLX_Green_Size, 1,
  GLX_Blue_Size , 1,
  GLX_Alpha_size, 1,
  GLX_DOUBLEBUFFER,
  GLX_DEPTH_SIZE, 24,0);
var
  Root : TWindow;
  Mask : Cardinal;
  Title: TXTextProperty;
begin

             h_dc := XOpenDisplay( nil );
         if @h_dc  = nil then exit;
           V_Info := glXChooseVisual( h_dc, DefaultScreen( h_dc ) , @ogl_Attr[0] );
       if @V_Info  = nil then exit;

  // Получаем идентификатор root-окна
             Root := RootWindow( h_dc, V_Info^.screen );
  // Создаем colormap
  Attr.colormap   := XCreateColormap( h_dc, Root, V_Info^.visual, AllocNone );;
  Attr.event_mask := ExposureMask      or FocusChangeMask or ButtonPressMask
                  or ButtonReleaseMask or PointerMotionMask or KeyPressMask
                  or KeyReleaseMask;

             Mask := CWColormap or CWEventMask or CWX or CWY;

            h_wnd := XCreateWindow( h_dc,
                                    Root,
                                    0, 0,
                                    Width, Height,// Ширина/Высота окна
                                    0, // Ширина рамки
                                    V_Info^.depth,
                                    InputOutput, // Окно будет на ввод/вывод
                                    V_Info^.visual,
                                    Mask,
                                   @Attr );

  if h_wnd = 0 Then begin
      WriteLn('Can''t create window');
      exit;
    end;

    XMapWindow( h_dc, h_wnd );

    WM_DelWnd := XInternAtom( h_dc, 'WM_DELETE_WINDOW', TRUE );
             XSetWMProtocols( h_dc, h_wnd, @WM_DelWnd, 1 );

  // Заносим имя в специальную структуру
  XStringListToTextProperty( @wndname, 1, @Title ); 
  // Устанавливаем имя заголовка
  XSetWMName(h_dc, h_wnd, @Title );

  glXWaitX;

  // пробуем Direct Render
      h_RC := glXCreateContext( h_dc, V_Info, nil, TRUE );
  if @h_RC = nil Then
    begin
      // пробуем Indirect Render
            h_RC := glXCreateContext( h_dc, V_Info, nil, FALSE );
        if @h_RC = nil Then exit;
    end;

  if not glXMakeCurrent( h_dc, h_wnd, h_RC ) Then exit;

end;

Function GetMessages:boolean;
var
  Event           : TXEvent;
begin
 result := false;

      while XPending( h_dc ) <> 0 do
        begin
          XNextEvent( h_dc, @Event );

          case Event._type of
            ClientMessage:
              begin
                if (Event.xclient.data.l[ 0 ]  = WM_DelWnd ) Then 
                     done:=true;
              end;
            MotionNotify:
              begin
                CursorPos[0] := Event.xmotion.X;
                CursorPos[1] := Event.xmotion.Y;
              end;
            ButtonPress:
              begin
                keys[vk_MouseLeft  ] :=     Event.xbutton.button = 1;
                keys[vk_MouseRight ] :=     Event.xbutton.button = 3;
                keys[vk_MouseMiddle] :=     Event.xbutton.button = 2;
              end;
            ButtonRelease:
              begin
                keys[vk_MouseLeft  ] := not Event.xbutton.button = 1;
                keys[vk_MouseRight ] := not Event.xbutton.button = 3;
                keys[vk_MouseMiddle] := not Event.xbutton.button = 2;
              end;

            KeyPress  : keys[ConvertKey( XLookupKeysym( @Event.xkey, 0 ) )] := true;
            KeyRelease: keys[ConvertKey( XLookupKeysym( @Event.xkey, 0 ) )] := false;
          end;

        end;
        result:=true;
end;
{$endif}

function GetTick: Integer;
  {$IFDEF WIN32}
  var
      T   : LARGE_INTEGER;
      F   : LARGE_INTEGER;
  {$else}
  var
    t_tmr : TimeVal;
  {$ENDIF}
begin
{$IFDEF WIN32}
  QueryPerformanceFrequency(Int64(F));
  QueryPerformanceCounter(Int64(T));
  Result := Trunc(1000 * T.QuadPart / F.QuadPart);
{$else}
  fpGetTimeOfDay( @t_tmr, nil );
  Result := t_tmr.tv_sec * 1000 + Round( t_tmr.tv_usec / 1000);
{$ENDIF}

end;

{ ------------------------------------------------------------------------ }
{ --Инит огла ------------------------------------------------------------ }
{ ------------------------------------------------------------------------ }
procedure glInit;
begin
    ReadExtensions;

    glEnable   (GL_DEPTH_TEST);      // Включаем глубинный тест
    glDepthFunc(GL_LESS);            // Его настройка
    glHint     (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); // Исправление текстур
    glEnable   (GL_TEXTURE_2D);      // Включаем текстуры

    glDisable(GL_CULL_FACE);         // Отключаем обрезание невидимых полигонов
    glViewPort(0, 0, Width, Height); // Разварачиваем огл окно

    if @pInit <> nil then
        pInit;
end;


{ ------------------------------------------------------------------------ }
{ --Уничтожение огл окна-------------------------------------------------- }
{ ------------------------------------------------------------------------ }
Procedure KillWnd;
begin
  if @pDestroy <> nil then pDestroy;

{$IfDef Win32}
  if fullscreen then                                //Если в полном экране то
  If ChangeDisplaySettings(DEVMODE(nil^),0)=0 then; //Смена разрешения на прошлое

  wglMakeCurrent(H_DC,0);                           //Отключаем OGL
  wglDeleteContext(H_RC);                           //Удаляем OGL
  ReleaseDC(H_Wnd,h_DC);                            //Освобажаем Канвас
  DestroyWindow(h_Wnd);                             //Удаляем окно
  UnRegisterClass(PrjName,hInstance);               //Удаляем класс
{$Else}
  if not glXMakeCurrent( h_dc, None, nil ) Then;

  glXDestroyContext( h_dc, h_rc);
  glXWaitGL;
  XDestroyWindow( h_dc, h_wnd);
  glXWaitX;
{$EndIf}
end;

Procedure CreateMainLoop;
begin
  AppDir := ExtractFilePath( ParamStr( 0 ) );
  
  InitOpenGL;

  CreateWND;                                     // Создание окна

  GLInit;                                        // Инициализация Ogl'a

  LastTime :=GetTick;
  FrameTime:=16;

  while Done=FALSE do                            // Пока игра незакончила делать
  if GetMessages then
  begin

      if @pProcess <> nil then
          pProcess;

      {$IfDef Win32}
        SwapBuffers(h_DC);                       // Переносим всё на экран
      {$Else}
        glXSwapBuffers( h_dc, h_wnd);
      {$EndIF}

     if  FPSTime <  LastTime then                // Проверка таймера 1с.
     begin
        FPS     := Frames;                       // Запоминаем колво уже отрисованных кадров
        Frames  := 0;                            // Обнуляем их
        FPSTime := LastTime + 1000;              // Устанавливаем этот таймер на 1 сек
     end;
      inc(Frames);                               // Увеличиваем колво кадров (нужно для подсчёта кадров в сек)

      FrameTime   := GetTick - LastTime;         // Расчёт скорости одного кадра
      LastTime    := GetTick;                    // Запоминаем прошлое время старта отрисоки кадра
   end;
  KillWnd;                                       // Если обработка окончина то мочим окно
end;

end.

